<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<div class="container">
  <div class="row">
    <form *ngIf="type.signaturePosition" class="col-6 ls-form " novalidate>
      <div class="form-group required">
        <ls-radio-buttons
          [(ngModel)]="type.signatureVisible"
          [items]="showStampValues"
          [legend]="messages.SHOW_STAMP_LABEL"
          name="isSignatureVisible">
        </ls-radio-buttons>
      </div>

      <div class="form-group large-tooltip">
        <label for=ShowStampOnPageInput>
          {{ messages.SHOW_STAMP_ON_PAGE_LABEL }}
          <ng-template #pageTooltip>
            <div
              class="text-start px-2"
              [innerHtml]="messages.PAGE_TOOLTIP">
            </div>
          </ng-template>
          <fa-icon
            class="ps-1"
            [icon]="commonIcons.TOOLTIP_ICON"
            [ngbTooltip]="pageTooltip"
            [openDelay]="300">
          </fa-icon>
        </label>
        <input
          [(ngModel)]="type.signaturePosition.page"
          class="form-control col-2"
          id=ShowStampOnPageInput
          name="signaturePositionPage"
          type="number">
      </div>

      <fieldset class="form-group">
        <legend [innerText]="messages.COORDINATES_LABEL"></legend>
        <div class="form-inline form-group">
          <div class="form-group">
            <label
              class="col-form-label"
              for=CoordinateXInput
              [innerText]="messages.COORDINATES_X_PT_LABEL">
            </label>
            <input
              (ngModelChange)="onChange()"
              [(ngModel)]="type.signaturePosition.x"
              [max]="math.round(pageWidthInPt - config.STAMP_WIDTH)"
              class="form-control"
              id=CoordinateXInput
              min="0"
              name="signaturePositionX"
              type="number">
          </div>
          <div class="form-group">
            <label
              class="col-form-label"
              [innerText]="messages.COORDINATES_X_MM_LABEL">
            </label>
            <span [innerText]="type.signaturePosition.x | ptToMm"></span>
          </div>
        </div>

        <div class="form-inline form-group">
          <div class="form-group">
            <label
              class="col-form-label"
              for=CoordinateYInput
              [innerText]="messages.COORDINATES_Y_PT_LABEL">
            </label>
            <input
              (ngModelChange)="onChange()"
              [(ngModel)]="type.signaturePosition.y"
              [max]="math.round(pageHeightInPt - config.STAMP_HEIGHT)"
              class="form-control"
              id=CoordinateYInput
              min="0"
              name="signaturePositionY"
              type="number">
          </div>
          <div class="form-group">
            <label
              class="col-form-label"
              [innerText]="messages.COORDINATES_Y_MM_LABEL">
            </label>
            <span [innerText]="type.signaturePosition.y | ptToMm"></span>
          </div>
        </div>
      </fieldset>

      <div class="alert alert-info">
        <fieldset class="form-group">
          <legend [innerText]="messages.SIZE_LABEL"></legend>
          <div class="form-inline form-group">
            <div class="form-group">
              <label
                class="col-form-label"
                [innerText]="messages.SIZE_W_PT_LABEL">
              </label>
              <span [innerText]="config.STAMP_WIDTH"></span>
            </div>

            <div class="form-group">
              <label
                class="col-form-label"
                [innerText]="messages.SIZE_W_MM_LABEL">
              </label>
              <span [innerText]="config.STAMP_WIDTH | ptToMm"></span>
            </div>

          </div>
          <div class="form-inline form-group">
            <div class="form-group">
              <label
                class="col-form-label"
                [innerText]="messages.SIZE_H_PT_LABEL">
              </label>
              <span [innerText]="config.STAMP_HEIGHT"></span>
            </div>

            <div class="form-group">
              <label
                class="col-form-label"
                [innerText]="messages.SIZE_H_MM_LABEL">
              </label>
              <span [innerText]="config.STAMP_HEIGHT | ptToMm"></span>
            </div>
          </div>
        </fieldset>
      </div>
    </form>

    <div class="form-group col-6 ls-form">
      <label [innerText]="messages.STAMP_PREVIEW_LABEL"></label>
      <span
        class="ls-info"
        [innerText]="messages.COORDINATES_LABEL_INFO">
      </span>
      <div class="preview-container">
        <div
          class="preview shadow"
          [ngStyle]="{
            'width': previewWidthInPx + 'px',
            'height': previewHeightInPx + 'px'
          }">
          <div
            [ngStyle]="{
              'bottom':type.signaturePosition.y * ratio + 'px',
              'left': type.signaturePosition.x * ratio + 'px',
              'width': config.STAMP_WIDTH * ratio + 'px',
              'height': config.STAMP_HEIGHT * ratio + 'px'
            }"
            class="position">
          </div>
        </div>
      </div>

      <button
        ls-button
        (click)="resetStampCustomization()"
        [icon]="messages.RESET_STAMP_CUSTOMIZATION_BUTTON_ICON"
        [text]="messages.RESET_STAMP_CUSTOMIZATION_BUTTON_TITLE"
        [weight]="weight.SECONDARY"
        class="float-end mt-3">
      </button>
    </div>
  </div>
</div>

